<?php
//
//	Module name      :	testodbcperm.php
//
//	Description      :	Test file for odbcperm module
//
//	Parameters       :	None
//	Notes - usage    :	None
//


//--- Include files --------------------------------------------------------------------------------



require_once("debug.php");
require_once("odbcperm.php");
require_once("odbc.php");
require_once("dblog.php");



//--- Global constants -----------------------------------------------------------------------------



define("PAGE_TIMER_NAME", "TestPage");
define("TEST_TIMER_NAME", "TestFunc");



//--- Global variables -----------------------------------------------------------------------------



$Module_prefix = "OP";



//--- Functions code -------------------------------------------------------------------------------



function PrintFooter()
// Prints the test page footer.
{
	print "
		<!--- Start of PrintFooter ------------------------------------------------------>
		</body>
		</html>";
	$sec = DMtimerRead(PAGE_TIMER_NAME);
	print "
		<!--- End of PrintFooter -------------------------------------------------------->
		<!--- (Elapsed seconds for page construction: $sec) ------------------------->
		";
}



function PrintHeader($browser_title)
// Prints the test page header.
{
	DMtimerReset(PAGE_TIMER_NAME);
	$now = gmdate('D, d M Y H:i:s') . ' GMT';
	header('Expires: ' . $now);						// rfc2616 - Section 14.21
	header('Last-Modified: ' . $now);
	header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
	header('Pragma: no-cache'); // HTTP/1.0
	print "
		<!--- Start of PrintHeader ------------------------------------------------------>
		<html>
		<head>
			<title>$browser_title</title>
			<meta http-equiv='content-type' content='text/html; charset=iso-8859-1'>
		</head>
		<body>
		<!--- End of PrintHeader -------------------------------------------------------->
		";
}



function Test()
// Calls DPrint for each parameter passed; if ErrorMsg and Result are defined in the tested module,
// calls them and shows their values after the last parameter evaluation. Returns the value of the last
// parameter evaluation.
{
	global $Module_prefix;
	static $first_call = TRUE;

	$em_name = "${Module_prefix}ErrorMsg";
	$em = function_exists($em_name);
	$r_name = "${Module_prefix}Result";
	$r = function_exists($r_name);
	for ($i = 0; $i < func_num_args(); $i++)
		$result = DPrint(func_get_arg($i));
	if ($first_call)
	{
		$first_call = FALSE;
		$msec = 0;
	}
	else
		$msec = DMtimerRead(TEST_TIMER_NAME);
	DMTimerReset(TEST_TIMER_NAME);
	print "
		<table border=1 cellspacing=1 cellpadding=3 width=100%>
		<tr valign=top>
			<td width=1%>
				<center><font style='visibility:hidden'><b>DPrint</b></font></center>
			</td>
			<td><font size=-1>
				" . ($r ? "<b>${Module_prefix}Result:</b> '" . call_user_func($r_name) . "';" : "") . "
				" . ($em ? "<b>${Module_prefix}ErrorMsg:</b> '" . call_user_func($em_name) . "';" : "") . "
				<b>Elapsed secs from last call:</b> $msec</font>
			</td>
		</tr></table><br>
		";
	return $result;
}



//--- Main code ------------------------------------------------------------------------------------



	DSetDebugWindow(D_WIN_DEF_X, D_WIN_DEF_Y, D_WIN_DEF_WIDTH, D_WIN_DEF_HEIGHT, FALSE);
	PrintHeader("Test file for " . constant("${Module_prefix}_MODULE_NAME"));
	Test("Initial internal status");

	// Test code for odbcperm.php starts here.

	$My_db = array("Dsn" => "prenotazioni", "User" => "apache", "Pwd" => "linuzzo");
	DPrint(ODBCInit($My_db), ODBCExtErrorMsg());
	
	DPrint("<font size=+1><font color=blue><b>OPInit</b></font></font>");
	$My_cfg = array(
			"UserTable"	=> array(
				"TableName"				=> "MyUser",
				"IdFieldName"			=> "MyId",
				"GidFieldName"			=> "MyGId",
				"NameFieldName"			=> "MyName",
				"DisabFieldName"		=> "MyDisabled"),
			"PermTable" => array(
				"TableName"				=> "MyPermission",
				"IdFieldName"			=> "MyId",
				"GidFieldName"			=> "MyGId",
				"MaskFieldName"			=> "MyNameMask",
				"FormFieldName"			=> "MyForm",
				"ViewsFieldName"		=> "MyViews",
				"ViewsNum"				=> 333,
				"ControlsFieldPrefix"	=> "MyControls",
				"ControlsNum"			=> 1010)
			);
	Test(OPInit($My_cfg, $My_db));
	DPrint($My_cfg);
	$My_cfg = array();
	Test(OPInit($My_cfg, $My_db));
	DPrint($My_cfg);

	DPrint("<font size=+1><font color=blue><b>OPDone</b></font></font>");
	Test(OPDone($My_cfg));
	DPrint($My_cfg);

	DPrint("<font size=+1><font color=blue><b>OPReadScriptPerm</b></font></font>");
	Test(OPInit($My_cfg, $My_db));
	Test(OPReadScriptPerm($My_cfg, "TestPath", "UserNonEsitente"));
	DPrint($My_cfg);
	Test(OPReadScriptPerm($My_cfg, "TestPath", "giubba"));			// Impostare prima qualche valore nel DB
	DPrint($My_cfg);
	DPrint("DbLog module init", DLInit("prenotazionilog", "log", ""), DLResult(), DLErrorMsg());
	$OP_db_log = TRUE;
	Test(OPReadScriptPerm($My_cfg, "TestPath", "UserNonEsitente"));
	Test(OPReadScriptPerm($My_cfg, "TestPath", "giubba"));			// Verificare la scrittura nel DB di log
	$OP_db_log = FALSE;
	Test(OPDone($My_cfg));

	DPrint("<font size=+1><font color=blue><b>OPFormPerm, OPViewPerm</b></font></font>");
	Test(OPInit($My_cfg, $My_db));
	Test(OPFormPerm($My_cfg), OPViewPerm($My_cfg), OPControlPerm($My_cfg));		// No permission
	Test(OPReadScriptPerm($My_cfg, "TestPath", "giubba"));
	Test(OPFormPerm($My_cfg));													// Some permission
	Test(OPViewPerm($My_cfg),
			OPViewPerm($My_cfg, 1), OPViewPerm($My_cfg, 2), OPViewPerm($My_cfg, 3),
			OPViewPerm($My_cfg, 4));
	Test(OPControlPerm($My_cfg),
			OPControlPerm($My_cfg, 1), OPControlPerm($My_cfg, 1, 1), OPControlPerm($My_cfg, 10),
			OPControlPerm($My_cfg, 11), OPControlPerm($My_cfg, 1, 4));

	// Test code for odbcperm.php ends here.

	Test("Final internal status");
	PrintFooter();	
?>
